"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeAPIGatewayEvent = exports.getAPIGatewayEventExecutor = void 0;
const quidproquo_webserver_1 = require("quidproquo-webserver");
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_actionprocessor_node_1 = require("quidproquo-actionprocessor-node");
const awsLambdaUtils = __importStar(require("../awsLambdaUtils"));
const getActionProcessor_1 = require("../getActionProcessor");
const lambdaConfig_1 = require("./lambdaConfig");
// @ts-ignore - Special webpack loader
const qpq_dynamic_loader_1 = __importDefault(require("qpq-dynamic-loader!"));
// TODO: Make this a util or something based on server time or something..
const getDateNow = () => new Date().toISOString();
const ErrorTypeHttpResponseMap = {
    [quidproquo_core_1.ErrorTypeEnum.BadRequest]: 400,
    [quidproquo_core_1.ErrorTypeEnum.Unauthorized]: 401,
    [quidproquo_core_1.ErrorTypeEnum.PaymentRequired]: 402,
    [quidproquo_core_1.ErrorTypeEnum.Forbidden]: 403,
    [quidproquo_core_1.ErrorTypeEnum.NotFound]: 404,
    [quidproquo_core_1.ErrorTypeEnum.TimeOut]: 408,
    [quidproquo_core_1.ErrorTypeEnum.UnsupportedMediaType]: 415,
    [quidproquo_core_1.ErrorTypeEnum.OutOfResources]: 500,
    [quidproquo_core_1.ErrorTypeEnum.GenericError]: 500,
    [quidproquo_core_1.ErrorTypeEnum.NotImplemented]: 501,
    [quidproquo_core_1.ErrorTypeEnum.NoContent]: 204,
    [quidproquo_core_1.ErrorTypeEnum.Invalid]: 422,
};
const getAPIGatewayEventExecutor = (dynamicModuleLoader, getCustomActionProcessors = () => ({})) => {
    return (event, context) => __awaiter(void 0, void 0, void 0, function* () {
        // Build a processor for the session and stuff
        // Remove the non route ones ~ let the story execute action add them
        const storyActionProcessor = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, quidproquo_actionprocessor_node_1.coreActionProcessor), quidproquo_actionprocessor_node_1.webserverActionProcessor), (0, getActionProcessor_1.getAPIGatewayEventActionProcessor)(lambdaConfig_1.lambdaRuntimeConfig.qpqConfig)), (0, getActionProcessor_1.getConfigGetSecretActionProcessor)(lambdaConfig_1.lambdaRuntimeConfig)), (0, getActionProcessor_1.getConfigGetParameterActionProcessor)(lambdaConfig_1.lambdaRuntimeConfig)), (0, getActionProcessor_1.getConfigGetParametersActionProcessor)(lambdaConfig_1.lambdaRuntimeConfig)), (0, getActionProcessor_1.getSystemActionProcessor)(dynamicModuleLoader)), (0, getActionProcessor_1.getFileActionProcessor)(lambdaConfig_1.lambdaRuntimeConfig)), getCustomActionProcessors(lambdaConfig_1.lambdaRuntimeConfig));
        const logger = (result) => __awaiter(void 0, void 0, void 0, function* () {
            // addResult(
            //   envConfig.appName,
            //   getDateNow(),
            //   doWeCarePath,
            //   "route-infrastructure",
            //   "infrastructure",
            //   "askRoute",
            //   result
            // );
        });
        //   // Run the callback
        const resolveStory = (0, quidproquo_core_1.createRuntime)({}, storyActionProcessor, getDateNow, logger, awsLambdaUtils.randomGuid);
        const result = yield resolveStory(quidproquo_core_1.askProcessEvent, [event, context]);
        // Run the callback
        if (!result.error) {
            return {
                statusCode: result.result.statusCode,
                body: JSON.stringify(result.result.body),
                headers: result.result.headers,
            };
        }
        console.log(JSON.stringify(result));
        const code = ErrorTypeHttpResponseMap[result.error.errorType];
        return {
            statusCode: code || 500,
            body: JSON.stringify(result.error),
            headers: quidproquo_webserver_1.qpqWebServerUtils.getCorsHeaders(lambdaConfig_1.lambdaRuntimeConfig.qpqConfig, {}, event.headers),
        };
    });
};
exports.getAPIGatewayEventExecutor = getAPIGatewayEventExecutor;
// Default executor
exports.executeAPIGatewayEvent = (0, exports.getAPIGatewayEventExecutor)(qpq_dynamic_loader_1.default);
